/*
 * Copyright 2003 - 2009 The eFaps Team
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * Revision:        $Rev: 3447 $
 * Last Changed:    $Date: 2009-11-29 17:46:39 -0500 (Sun, 29 Nov 2009) $
 * Last Changed By: $Author: tim.moxter $
 */

package org.efaps.ui.wicket.components.button;

import org.apache.wicket.Component;
import org.apache.wicket.behavior.AbstractBehavior;
import org.apache.wicket.markup.ComponentTag;
import org.apache.wicket.markup.html.IHeaderResponse;
import org.apache.wicket.markup.html.WebMarkupContainer;
import org.apache.wicket.markup.html.basic.Label;

import org.efaps.ui.wicket.resources.EFapsContentReference;

/**
 * @author jmox
 * @version $Id: ButtonStyleBehavior.java 3447 2009-11-29 22:46:39Z tim.moxter $
 */
public class ButtonStyleBehavior extends AbstractBehavior {

  private static final long serialVersionUID = 1L;

  public final static EFapsContentReference CSS =
      new EFapsContentReference(ButtonStyleBehavior.class,
          "ButtonStyleBehavior.css");

  /*
   * (non-Javadoc)
   *
   * @see org.apache.wicket.behavior.AbstractBehavior#renderHead(org.apache.wicket.markup.html.IHeaderResponse)
   */
  @Override
  public void renderHead(final IHeaderResponse _response) {
    super.renderHead(_response);
    _response.renderCSSReference(CSS.getStaticContentUrl());
  }

  /*
   * (non-Javadoc)
   *
   * @see org.apache.wicket.behavior.AbstractBehavior#onComponentTag(org.apache.wicket.Component,
   *      org.apache.wicket.markup.ComponentTag)
   */
  @Override
  public void onComponentTag(final Component _component, final ComponentTag _tag) {
    super.onComponentTag(_component, _tag);
    if (_component instanceof WebMarkupContainer) {
      _tag.put("class", "eFapsButton");
    }
    if (_component instanceof Label) {
      _tag.put("class", "eFapsButtonLabel");
    }
  }

}
